module Nestene
  class AutonContext

    def initialize auton_id
      @auton_id = auton_id
    end

    attr_accessor :steps_to_schedule

    def schedule_callback auton_id, method, parameters, callback_method
      Celluloid::Actor[:nestene_core].schedule_step auton_id, method, parameters, @auton_id, callback_method
    end

    def schedule_step name, parameters=[]
      Celluloid::Actor[:nestene_core].schedule_step @auton_id, name, parameters
    end

    def schedule_step_on_auton auton_id, name, parameters=[]
      Celluloid::Actor[:nestene_core].schedule_step auton_id, name, parameters
    end


    def schedule_delayed_step delay, name, parameters=[]
      Celluloid::Actor[:nestene_core].schedule_delayed_step @auton_id, delay, name, parameters
    end

    def schedule_repeating_delayed_step every, delay, name, parameters=[]
      Celluloid::Actor[:nestene_core].schedule_repeating_delayed_step @auton_id, every, delay, name, parameters
    end

    def credentials
      Celluloid::Actor[:nestene_core].get_credentials
    end

    def create_auton type, auton_id=SecureRandom.uuid
      Celluloid::Actor[:nestene_core].create_auton type, auton_id
    end

    def terminate
      schedule_step '__terminate_this_auton'
    end

    attr_reader :auton_id

  end
end