module Nestene
  class ExecutedMethod
    include StructureMapper::Hash

    def initialize(executing_method = nil)
      self.parameters = []
      if executing_method
        self.name = executing_method.name
        self.parameters = executing_method.parameters
        self.uuid = executing_method.uuid
        self.scheduled_at = executing_method.scheduled_at
        self.started_at = executing_method.started_at
        self.duration = Time.now - executing_method.started_at
        self.callback = executing_method.callback
      end
    end

    attribute name: Symbol
    attribute parameters: []
    attribute uuid: String
    attribute result: {}
    attribute error: Exception
    attribute scheduled_at: Time
    attribute started_at: Time
    attribute duration: Float
    attribute callback: Callback

  end
end